plugins {
    id("java-library")
    id("chat-bot.java-conventions")
}

group = "eu.jonahbauer.chat"
version = "0.1.0-SNAPSHOT"

sourceSets {
    create("config") {
        java {
            srcDir("src/config/java")
        }
    }
}

java {
    registerFeature("config") {
        usingSourceSet(sourceSets["config"])
    }
}

val configApi by configurations
val configCompileOnly by configurations
val configAnnotationProcessor by configurations

dependencies {
    api(libs.annotations)
    api(project(path)) {
        capabilities {
            requireCapability("${project.group}:${project.name}-config")
        }
    }
    implementation(libs.gson)

    configApi(libs.annotations)
    configCompileOnly(libs.lombok)
    configAnnotationProcessor(libs.lombok)
}

tasks.withType<JavaCompile> {
    options.compilerArgs.add("-Xlint:-module")
}